<template>
  <v-container
    fluid
    class="fill-height"
  >
    <v-row
      justify="center"
      align="start"
      class="fill-height"
    >
      <!-- score and nicknames -->
      <v-col
        cols="4"
        class="text-h4"
        align="end"
      >
        <trivia-match-score :results="match.me.results" />
      </v-col>
      <v-col
        cols="4"
        class="text-h3"
      >
        {{ match.me.nickname }} v {{ match.opponent.nickname }}
      </v-col>
      <v-col
        cols="4"
        class="text-h4"
        align="start"
      >
        <trivia-match-score :results="match.opponent.results" />
      </v-col>

      <!-- playing -->
      <template v-if="match.questions[match.questionIndex]">
        <!-- question -->
        <v-col
          cols="12"
          class="text-h5"
        >
          <v-icon icon="mdi-head-question" />
          {{ match.questions[match.questionIndex].question }}
        </v-col>

        <!-- answer -->
        <v-col cols="4" />
        <v-col cols="4">
          <v-text-field
            v-model="answer"
            label="Answer"
            variant="outlined"
            @keyup.return="submitAnswer"
            @keyup.enter="submitAnswer"
          />
        </v-col>
        <v-col cols="4" />
        <v-col>
          <v-btn
            outlined
            color="success"
            @click="submitAnswer"
          >
            Submit
          </v-btn>
        </v-col>
      </template>
      <!-- done -->
      <template v-else-if="!match.finished">
        <v-col cols="4">
          waiting for {{ match.opponent.nickname }} to finish answering all questions
        </v-col>
      </template>

      <!-- match result -->
      <template
        v-if="match.finished"
      >
        <v-col
          cols="12"
          class="text-h5"
        >
          <template v-if="match.result=='draw'">
            <span class="warning"> the match finished in a draw</span>
          </template>
          <template v-else-if="match.result=='win'">
            <span class="success">you won :-)</span>
          </template>
          <template v-else>
            <span class="error">you lost :-(</span>
          </template>
        </v-col>
        <v-col
          class="text-center"
        >
          <v-btn
            color="success"
            size="x-large"
            rounded="xl"
            elevated
            stacked
            @click="finishMatch"
          >
            Done
          </v-btn>
        </v-col>
      </template>
    </v-row>
  </v-container>
</template>

<script setup lang="ts">
import { ref } from "vue"
import { put } from "aws-amplify/api"
import TriviaMatchScore from "./TriviaMatchScore.vue"

import { useMatchStore } from "@/stores/matchStore.js"
const matchStore = useMatchStore()

let answer = ref("")

const props = defineProps({
  match: { type: Object, required: true }
})

const emit = defineEmits(["onMatchFinished"])

const finishMatch = () => {
  matchStore.finishMatch()
  emit("onMatchFinished")
}

const submitAnswer = async () => {
  try {
    const match = props.match

    const restOperation = put({
      apiName: "fanfesttrivia",
      path: "/trivia/answer",
      options: {
        body: {
          matchId: match.id,
          questionId: match.questions[match.questionIndex].id,
          answer: answer.value
        }
      }
    })

    const { body } = await restOperation.response
    const response = await body.json()
    console.log("PUT call succeeded")
    console.log(response)

    answer.value = ""
    matchStore.nextQuestion()
  } catch (error) {
    console.error(error)
  }
}

</script>

<style></style>
